package me.km.entities;

import com.mojang.blaze3d.matrix.MatrixStack;
import me.km.KajetansMod;
import net.minecraft.client.renderer.entity.EntityRendererManager;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.model.PolarBearModel;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

@OnlyIn(Dist.CLIENT)
public class RenderBlackBear extends MobRenderer<EntityBlackBear, PolarBearModel<EntityBlackBear>> {
    private static final ResourceLocation BLACK_BEAR_TEXTURE = new ResourceLocation(KajetansMod.MODID, "textures/entity/bear/blackbear.png");

    public RenderBlackBear(EntityRendererManager erm) {
        super(erm, new PolarBearModel<>(), 0.9F);
    }

    @Override
    public ResourceLocation getEntityTexture(EntityBlackBear entity) {
        return BLACK_BEAR_TEXTURE;
    }

    @Override
    protected void preRenderCallback(EntityBlackBear ent, MatrixStack mStack, float partialTickTime) {
        mStack.scale(1.2F, 1.2F, 1.2F);
        super.preRenderCallback(ent, mStack, partialTickTime);
    }
}
